# encoding: utf-8
module Belka
  module Data
    # http://taina.aib.ru/names/man/man-a.htm
    MaleNames = %w{
      Абрам Авраам Ибрагим Аввакум Аввакуум Аббакум Август Августин
      Авдей Авенир Аверьян Аверкий Авксентий Агап Агафон Агей Азарий
      Адам Адольф Адриан Акакий Аким Алан Александр Алексей Алоис
      Альберт Альбин Альфред Амадей Амвросий Ананий Анжей Анастасий
      Анатолий Андрей Андриан Андроник Андрон Анисим Антип Антон
      Ануфрий Аполинарий Аполлон Аристарх Аркадий Арнольд Арсен
      Арсений Артем Артемий Артур Архип Аскольд Атанас Аурелий
      Аурелиус Афанасий Афиноген Бажен Бальтазар Бенедикт Бернанд
      Бертран Богдан Болеслав Бонавентура Борис Бронислав Бруно Булат
      Вавила Вадим Валентин Валериан Валерьян Валерий Вальтер Варлаам
      Варлам Варфоломей Василий Вацлав Велор Велорий Венедикт Вениамин
      Викентий Виктор Вилли Винсент Виргилий Виссарион Вит Виталий
      Витольд Владимир Владислав Владлен Влас Вольдемар Всеволод
      Вячеслав Габриель Гавриил Галактион Гарри Геннадий Генрих
      Георгий Егор Геракл Геральд Герасим Герман Глеб Годфрид Гордей
      Грегор Григорий Гурий Густав Давыд Давид Даниил Данила Дементий
      Демид Демьян Денис Джордан Димитрий Дмитрий Дональд Донат
      Дормидонт Дорофей Евгений Евграф Евдоким Евлампий Евсевий Евсей
      Евстафий Евстахий Евстигней Евстрат Елизар Елисей Емельян Епифан
      Еремей Ермолай Ерофей Ефим Ефрем Жерар Захар Зенон Зигфрид
      Зиновий Зосима Иакинф Иван Иво Игнат Игнатий Игорь Измаил
      Изяслав Илларион Илья Имил Эмилий Иннокентий Иона Иосиф Осип
      Ипат Ипполит Ираклий Геракл Иржи Исаак Исидор Сидор Казимир
      Каллистрат Камилл Капитон Карл Карол Карп Касьян Ким Киприан
      Кирилл Кирьян Клавдий Клеменс Клемент Клим Климент Климентий
      Кондратий Кондрат Конрад Константин Корнелий Корнилий Корней
      Кристиан Кристоф Кронид Ксавер Ксенофонт Кузьма Лавр Лаврентий
      Лазарь Лев Леон Леонард Леонид Леонтий Леопольд Лука Лукьян
      Любомир Людвиг Люсьен Май Макар Макарий Максим Максимилиан
      Мануэль Марек Мариан Мариус Марк Марсель Мартин Мартын Масей
      Матвей Матеуш Мауриций Медард Мелентий Мефодий Мечеслав Мечислав
      Милан Милон Мирон Мирослав Митрофан Михаил Модест Моисей
      Мстислав Назар  Назарий Наполеон Натан Нафан Наркисс Нарцисс
      Наум Нестор Никандр Никанор Никита Никифор Никодим Николай Никон
      Нил Нисон Норберт Овидий Олаф Олег Олесь Онисим Орест Осип Оскар
      Остромир Павел Памфил Панфил Панкрат Пантелеймон Пантелей
      Парамон Парфен Патрик Патрикей Паулин Пахом Петр Пимен Платон
      Поликарп Порфирий Прокл Прокоп Прокофий Прокопий Протас Прохор
      Ратибор Ратмир Рафаил Рафаэль Ринат Ренат Ричард Роберт Роджер
      Родион Роланд Роман Рональд Ростислав Рубен Рудольф Руслан Рюрик
      Савва Севастьян Савелий Самсон Самуил Святополк Святослав
      Севастьян Северьян Селестин Семен Серафим Сергей Сила Сильвестр
      Серж Соломон Спартак Спиридон Станислав Степан Тарас Теодор
      Теофил Терентий Тимофей Тимур Тит Тихон Томас Трифон Трофим
      Ульрих Устин Фабиан Фаддей Федор Федот Феликс Фелициан Феодосий
      Феофан Фердинанд Филимон Филипп Флор Флориан Фома Франц Фридрих
      Харитон Харольд Христиан Христофор Цезарь Эварист Эдвард Эдгар
      Эдмунд Эдуард Эдвард Эмерик Эмиль Эммануил Эммануэль Эразм Эраст
      Эрик Эрнест Юлиан Юлий Юрий Юхим Яков Ян Януарий Яромир
      Ярослав}.freeze

    # http://taina.aib.ru/names/woman/woman-a.htm
    FemaleNames = %w{
      Августа Августина Аврора Агата Агафья Аглая Аглаида Агнесса
      Агния Агриппина Ада Аделаида Аделина Адриана Аза Акулина
      Алевтина Александра Алина Алиса Алла Альберта Альбертина Альбина
      Альфреда Амелия Анабела Анастасия Ангелина Анжела Анжелика
      Анисья Анита Аниэла Анна Антонина Анфиса Апполинария Аполлония
      Арабелла Ариадна Астра Аурелия Аурика Барбара Беата Беатриса
      Белла Бенедикта Бернадета Берта Бибиана Бланка Богдана Болеслава
      Борислава Бригитта Бронислава Валентина Валерия Ванда Варвара
      Варя Василиса Васса Венера Вера Вероника Веста Ветта Иветта
      Вивиана Виктория Вильгельмина Виолетта Вирджиния Виринея Виталия
      Виталина Владислава Владлена Габриела Галина Гаянэ Гелена Гелла
      Генриетта Гертруда Гизелла Глафира Гликерия Глория Гортензия
      Грация Дайна Далия Дана Даниела Данута Дарья Дебора Джульетта
      Диана Дина Доля Доминика Дора Дорота Дорофея Ева Евгения Евдокия
      Евпраксия Евтебия Екатерина Елена Елизавета Ефросиния Жанна
      Жеральдина Жозефина Забава Зинаида Зита Злата Зоя Ивона Изабелла
      Изольда Инара Инга Инесса Инна Иоанна Иоланта Ираида Ирена Ирина
      Ирма Ия Калерия Камилла Капитолина Карен Карина Каролина
      Катарина Кира Клавдия Клара Климентина Клотильда Констанция Кора
      Кристина Ксавера Ксения Лада Лайма Лариса Лаура Лена Леокадия
      Леонтина Леся Лиана Лидия Лилиана Лилия Лиля Лия Лола Лолита
      Лолла Луиза Лукреция Любовь Людмила Люсина Люся Люция Лючия
      Магдалена Магдалина Майя Мануэла Маня Маргарита Марианна Марина
      Мариэтта Мария Марлена Марселина Марта Марфа Матильда Матрена
      Матрона Медея Мелания Милена Милица Мира Мирра Мирдза Мирра
      Михалина Моника Муза Надежда Наина Наталья Наталия Наташа Нелли
      Неонила Нила Ника Нина Нинель Нонна Нора Одетта Оксана Октавия
      Октябрина Олеся Ольга Памела Патриция Паула Паулина Пелагея
      Петиция Полина Прасковья Пульхерия Рада Раиса Рахиль Ревекка
      Регина Рина Рената Римма Рита Роберта Роза Розалия Розамунда
      Роксана Ростислава Руслана Руфина Сабина Сандра Сарра Сара
      Светлана Северина Селестина Селина Серафима Сивилла Сильва
      Сильвия Симона Сиотвия Соломея Соня София Софья Станислава
      Стелла Стефанида Стефания Сузанна Сусанна Сюзанна Таира Таисия
      Таисья Тамара Татьяна Текла Теодора Тереза Томила Тамила Ульяна
      Устинья Урсула Фаина Фёкла Фелиция Феодора Феодосия Филиппина
      Филомена Флора Франсуаза Фредерика Фрида Хильда Хильдегарда
      Христина Цецилия Эвелина Эдита Юдифь Эдмунда Элеонора Элиана
      Элина Элиза Элизабет Элла Эльвира Эльза Эмилия Эмма Эмма Эрика
      Эрнестина Эстер Эстера Юдита Юлия Юнона Ядвига Яна Янина
      Ярослава}

    # http://taina.aib.ru/otchectv/man/index.htm
    MaleMiddleNames = %w{
      Александрович Алексеевич Альбертович Анатольевич Андреевич
      Антонович Аркадьевич Артемович Богданович Богуславович Борисович
      Вадимович Валентинович Валерьевич Васильевич Вениаминович
      Викторович Владимирович Вячеславович Геннадиевич Георгиевич
      Григорьевич Давидович Данилович Денисович Дмитриевич Евгеньевич
      Егорович Ефимович Иванович Игоревич Ильич Иосифович Кириллович
      Константинович Львович Леонидович Макарович Максимович Максович
      Матвеевич Миронович Михайлович Натанович Наумович Николаевич
      Олегович Оскарович Павлович Петрович Платонович Робертович
      Романович Ростиславович Рубенович Рудольфович Русланович
      Святославович Семенович Сергеевич Станиславович Степанович
      Тарасович Тимофеевич Тимурович Федорович Феликсович Филиппович
      Эдуардович Эльдарович Юрьевич Яковлевич Ярославович}

    # http://taina.aib.ru/otchectv/woman/index.htm
    FemaleMiddleNames = %w{
      Александровна Алексеевна Альбертовна Анатольевна Андреевна
      Антоновна Аркадьевна Артемовна Артуровна Архиповна Аскольдовна
      Афанасьевна Богдановна Болеславовна Борисовна Вадимовна
      Валентиновна Валериевна Васильевна Вениаминовна Викторовна
      Владимировна Владиславовна Вячеславовна Владиславовна
      Геннадиевна Георгиевна Григорьевна Даниловна Денисовна
      Дмитриевна Евгеньевна Егоровна Ефимовна Ждановна Ивановна
      Игоревна Ильинична Кирилловна Константиновна Кузминична Леоновна
      Львовна Леонидовна Макаровна Максимовна Матвеевна Мироновна
      Михайловна Натановна Наумовна Никифоровна Николаевна Ниловна
      Олеговна Оскаровна Павловна Петровна Робертовна Романовна
      Рубеновна Рудольфовна Руслановна Святославовна Семеновна
      Сергеевна Степановна Станиславовна Тарасовна Тимофеевна
      Тимуровна Федоровна Феликсовна Филипповна Эдуардовна Эльдаровна
      Юльевна Юрьевна Яковлевна}

    # http://b23.ru/qiu
    FamilyNames = %w{
      Абакумов Абарников Абдулов Абрамов Авдеев Аверин Аверьянов
      Авилов Автухов Агапов Агафонов Агейкин Ажищенков Азаров Аксаков
      Аксёнов Алеев Аленин Алиев Алистратов Алогрин Амалиев Амелин
      Аминев Александров Алексеев Алёхин Аллилуев Андреев Андреюшкин
      Андроников Андропов Аниканов Анисимов Анишин Анников Анохин
      Аношкин Антипов Антонов Апалков Артамонов Арефьев Арзамасцев
      Аристархов Арсеньев Артёмов Асланов Аслаханов Астанков Астафьев
      Астахов Афанасьев Афонин Аспидов Бабанин Бабатьев Бабиков
      Бабичев Бабкин Бабурин Багров Бакрылов Бажанов Баженов Базанов
      Базаров Балакин Баландин Балахнов Балашов Бальсунов Баранов
      Барболин Баренцев Баринов Барков Барсуков Батрутдинов Безбородов
      Безруков Безукладников Белибердиев Беликов Белов Беломестнов
      Беломестов Белочкин Бендлин Березин Белоусов Бершов Беспалов
      Бескрёстнов Бехтерев Бирюков Блаженов Блатов Блинов Блохин
      Бобров Богатырёв Богданов Боголепов Боголюбов Богомазов
      Богомолов Богров Бойков Бойцов Болотников Болтоногов Большов
      Бондарев Бондарчюк Бореев Бочаров Борзилов Борцов Брагин Брежнев
      Бугаков Буданов Будников Будылин Букин Буклин Булгаков Булыгин
      Бунин Бурков Буров Бурцов Буряков Бутылин Быков Былинкин Бычков
      Вавилов Вагин Вазов Варенников Васильев Васин Васнев Васнецов
      Вахров Вахрушев Венедиктов Веденеев Веденин Ведерников Вергунов
      Верещагин Вершинин Веселов Викашев Виноградов Винокуров Витаев
      Витвинин Вицин Вихров Водоватов Воликов Волков Вольваков
      Воробьев Воронин Воронов Воронков Воронцов Воскобойников Вотяков
      Вырыпаев Гавриков Гаврилов Гагарин Гаголин Галдин Галиаскаров
      Галкин Галыгин Гарин Гачев Генкин Герасимов Гибазов Гилёв
      Глазков Голов Голованов Головин Голодяев Голубев Голубов
      Голубцов Гончаров Горбачёв Горбунов Горбунков Горев Горелов
      Горемыкин Горюнов Грачёв Графов Грешнев Грибов Грибоедов
      Григорьев Гринин Гришин Громов Губанов Гулин Гурьянов Гусаров
      Гусев Гунин Гущин Горохов Дорофеев Давыдкин Данильцин Двойнев
      Дворников Деменок Дементьев Демидов Деникин Дёгтин Дегтярев
      Дежнёв Делов Дементьев Дёмин Державин Дернов Десятков Дмитриев
      Добронравов Добрынин Долгоруков Должиков Домашев Достовалов
      Драгомиров Дресвянин Дрёмов Друганин Другов Дубинин Дубов
      Дульцев Дуров Дятлов Дураничев Евдокимов Евстигнеев Егоров Ежов
      Елагин Елизаров Елисеев Ельцин Ельцов Емельянов Енин Енотин
      Енотов Ерзов Ермаков Ермилов Еромеев Ерофеев Ершов Есипов Ефимов
      Ефремов Емелин Ерохин Ерёмин Ёжин Ёжов Ёлкин Ёлков Жабин Жарков
      Жарыхин Жвиков Жданов Жеглов Железкин Железнов Жестаков Живенков
      Жиглов Жигунов Жидков Жикин Жилин Жилов Жолдин Жуков Жутов
      Журавлёв Журов Заврагин Завражин Завражнов Завразин Завьялов
      Задорнов Зайцев Закрятин Захаров Захарьин Звягин Зефиров Зёмин
      Зимин Злобин Золин Золотов Зонов Зубков Зубов Зуев Зуйков
      Зимняков Зыкин Зыков Зырянов Зюганов Зверев Игнаткович Ивазов
      Ивакин Ибрагимов Иванов Иванков Ивашин Ивашов Ивкин Иволгин
      Игнатьев Игошин Исмайлов Измайлов Изюмов Иканов Икашев Ильин
      Илюшин Ильюшин Иноземцев Ипатьев Исаев Истомин Кабинов Каблуков
      Каверин Кадников Кадцын Казаков Казанцев Казарезов Калганов
      Калягин Камкин Канадин Канадов Канадцев Каналин Капралов
      Каприянов Капустин Караваев Карандашов Карантиров Караулин
      Караулов Карев Каретников Каргин Карташов Карчагин Катериночкин
      Катин Качусов Кашарин Каширин Кашканов Кашников Киприянов Киреев
      Кирилов Кирсанов Кирьянов Клепахов Климов Климушин Климцов
      Клоков Князев Ковалёв Ковров Ковшутин Кожуров Кожухов Козаков
      Козлов Колесников Коллеров Колонтаев Колосов Кольцов Комаров
      Комзин Комолов Кондратьев Кондюрин Конев Конников Коновалов
      Коньяков Коняшев Копейкин Кораблёв Кораблин Коренев Коренёв
      Коржаков Коржев Корнев Корнеев Корнилов Коровин Королёв Коротаев
      Корчагин Косарёв Косков Косомов Косоруков Костин Костомаров
      Котов Коченков Кошелев Кошечкин Кошкин Краев Краснов Красноперов
      Кропанин Кругликов Круглов Крупин Крутин Кручинкин Крылов Крысов
      Крюков Кубланов Кудашов Кудрин Кудрявцев Кудряшов Кузнецов
      Кузубов Кузьмин Куимов Куклачёв Куклин Куклов Кулагин Кулаков
      Кулибин Куликов Куракин Курбатов Курганов Курдин Курепин
      Курпатов Курсалин Курчин Кутепов Кутиков Кутузов Кутяков
      Лаврентьев Лавров Лагутов Лазарев Ланцов Лапотников Лаптев
      Лапунов Лапухов Ларин Ларионов Ласкутин Лачинов Лачков Лебедев
      Лебединцев Легкодимов Ледовской Леонидов Леонов Лепёхин Лесков
      Летов Лёвкин Лешев Лещёв Лилов Лимонов Липин Лисицын Листунов
      Лихачёв Лобанов Лобов Логинов Локтев Ломоносов Ломтев Лопатин
      Лосев Лоскутников Лоскутов Лужков Луков Лукин Львов Лыткин
      Любимов Любимцев Любов Левкин Лягушкин Лягушов Лялюшкин Ляпин
      Лясин Мадулин Мажулин Макаров Маклаков Максимов Максимушкин
      Максудов Малахов Маликов Малинин Малышев Мальчиков Малыхин
      Малюгин Мамонов Манин Манякин Маркин Марков Маринин Марьин
      Маслов Матвеев Машарин Медведев Медведков Медников Меледин
      Мелехов Меликов Мельников Меншиков Менщиков Меркушев Мещеряков
      Мигунов Мизенов Милехин Милорадов Милюков Милютин Минеев Минин
      Минкин Миров Мирнов Миронов Митин Митрофанов Михайлов Михалев
      Михеев Мишнев Мишутин Моисеев Молчанов Моренов Морозов Моряков
      Мосалев Москвин Муратов Мухортов Мягков Мясников Мятлев Набатов
      Нардин Наумов Невзоров Неделяев Нежданов Немцев Немцов Ненашев
      Нестеров Нечаев Никитин Никифоров Никишин Николаев Никонов
      Никулин Некрасов Новиков Новичков Новосельцев Носачёв Носков
      Носов Нуриев Оборин Образцов Обухов Овечкин Огородников Огурцов
      Озеров Оленев Онегин Опокин Орлов Осин Осинов Осинцев Осокин
      Осолодкин Остальцев Островерхов Ошурков Павлов Панарин Панин
      Панкин Панков Панфилов Папанов Пасхин Патрушев Пахомов Пашин
      Пашков Пенкин Переверзев Перевёртов Пересторонин Перехваткин
      Перов Перфильев Перьмяков Пестов Петров Петухов Печеников Печкин
      Пивоваров Пирогов Пирожков Пичугин Пичушкин Пищальников
      Племянников Погодин Погодов Погребнов Подшивалов Поздняков
      Поливанов Половцев Полотенцев Полунин Полушин Поляков
      Помельников Поникаров Пономарёв Пончиков Попов Попырин Посохов
      Потапов Потёмкин Праздников Прибылов Привалов Примаков Пронин
      Проничев Протасов Прохоров Пугачёв Пугин Пузаков Пузанов Путилин
      Путилов Путин Путинов Путятин Пушкин Пыжалов Пырьев Разин
      Разуваев Распопов Распутин Рассказов Расторгуев Ремизов Репин
      Решетилов Решетников Ржевский Рогачёв Рогов Рогозин Рожков
      Романов Ростов Ростовцев Рубашкин Рудавин Рудников Румянцев
      Рунов Русаков Ручкин Рыбалкин Рыбаков Рыжанов Рыжков Рыжов Рыков
      Рытин Рыченков Рюриков Рябкин Рябков Рябов Рябцев Ряхин Сабанцев
      Сабитов Савасин Савинков Савенков Саврасов Садыков Сазонов
      Салтанов Сальков Сальников Самойлов Самохин Самсонов Санников
      Сапогов Сапожников Сапрыкин Сафиюлин Сафронов Сахаров Свалов
      Северинов Севостьянов Седельников Седов Селезнёв Селиванов
      Семёнов Сенькин Сергеев Серебров Серебряков Серёгин Серов
      Серпионов Семянин Сёмин Сеченов Сиваков Сигаев Сигачёв Сидоров
      Сизов Силиванов Силин Сильвестров Силаев Силиванов Ситников
      Скворцов Скрябин Скоробогатов Скороходов Скуратов Слобожанин
      Смагин Смирнов Сметанин Смолин Смолянинов Смотров Снаткин
      Снегирёв Снетков Соболев Соколов Солдатов Соловьёв Солодников
      Соломин Соломонов Сопов Сорокин Спанов Сталин Стариков Старцев
      Староверов Староволков Стародубов Стародубцев Стеблев Стегнов
      Степанов Степанков Степашин Стрелков Стрекалов Строганов
      Субботин Суботин Суворин Суворкин Суворов Сунгатулин Сукачев
      Сукин Султанов Суриков Сусоев Сусляков Сутулин Суханов Сухоруков
      Сучков Сысоев Сытников Сычёв Сычкин Сюкосев Табаков Табернакулов
      Таланов Талалихин Танков Тарасов Татаров Татауров Твардовский
      Тёмкин Телицын Теплов Теребов Терёшин Тетерев Тимошкин Типалов
      Титов Тихомиров Тихонов Ткачёв Токарев Токмаков Толбанов
      Толкачёв Толмачёв Толстобров Толстокожев Топоров Торопов Травкин
      Трактирников Третьяков Трифонов Трофимов Трусов Трутнев Труфанов
      Трухин Трындин Туполев Турбин Тургенев Туров Турфанов Тычкин
      Тюшняков Тянников Убейсобакин Угольников Ульянов Ульяшин
      Успенский Усатов Усачёв Усов Устинов Устюжанин Утёсов Ухов Фанин
      Фамусов Федин Федосов Федотов Федосеев Федченков Фёдоров Федулов
      Фетисов Филатов Филимонов Филипов Филиппов Флёров Фокин Фоменков
      Фомин Фомичев Фонвизин Форопонов Фирсов Фролов Францев Фукин
      Хабалов Хабаров Хабенский Халипов Халтурин Ханилов Ханипов
      Ханцев Харитонов Харламов Хлебов Хлебников Хлопонин Хмельнов
      Ходяев Холодов Хомколов Храмов Хребтов Хромов Хрущёв Худовеков
      Худяков Хуртин Царицын Царёв Цветаев Цветков Цирюльников
      Цитников Цуканов Чаадаев Чадов Чазов Чапаев Чеботарёв Чебыкин
      Чежеков Чекмарёв Челомеев Челомцев Челпанов Чендев Черенчиков
      Черепанов Черкашин Чернов Чернаков Черников Чернышёв Чесноков
      Чиграков Чижиков Чилаев Чистяков Чичиков Чичканов Чкалов Чмыхов
      Чугунов Чудов Чужинов Чукчов Чукреев Чупахин Чупов Чуприн Чупров
      Чуркин Чучанов Чучумашев Шабунин Шакмаков Шаляпин Шаповалов
      Шапошников Шарапов Шаров Шаршин Шашлов Шведов Шеломов Шепкин
      Шеповалов Шереметьев Шерстов Шикалов Ширманов Шихранов Шишкин
      Шишлов Шишов Шкуратов Шлыков Шмаков Шмелев Шубин Шубкин Шувалов
      Шукшин Шулёв Шульдешов Шульгин Шурупов Шушалев Щеглов Щеголев
      Щеголихин Щедрин Щедров Щекочихин Щепкин Щербаков Щербин Щетинин
      Щеткин Щукин Щуров Энтин Ювелев Юганцев Югов Юдачёв Юдашкин Юдин
      Юнкин Юракин Юрнаев Юрьев Юсупов Ютилов Юферев Якимов Яковлев
      Якубов Якунин Якушев Якушин Янаев Янков Яромеев Ярцев Ясенев
      Яснеев Яшин} +
      [ [ "Аксенчук", '', '' ],
        [ "Антонович", '', '' ],
        [ "Бебчук", '', '' ],
        [ "Безродн", 'ый', 'ая' ],
        [ "Беломестн", 'ый', 'ая' ],
        [ "Беломестных", '', '' ],
        [ "Бережн", 'ой', 'ая' ],
        [ "Бобр", '', '' ],
        [ "Бобрик", '', '' ],
        [ "Бойдало", '', '' ],
        [ "Бок", '', '' ],
        [ "Бортник", '', '' ],
        [ "Букирь", '', '' ],
        [ "Бухало", '', '' ],
        [ "Валевач", '', '' ],
        [ "Головаха", '', '' ],
        [ "Голумбовск", 'ий', 'ая' ],
        [ "Гретченко", '', '' ],
        [ "Гречко", '', '' ],
        [ "Григолюк", '', '' ],
        [ "Громыко", '', '' ],
        [ "Гурковск", 'ий', 'ая' ],
        [ "Дубровск", 'ий', 'ая' ],
        [ "Думановск", 'ий', 'ая' ],
        [ "Едемск", 'ий', 'ая' ],
        [ "Емельяненко", '', '' ],
        [ "Ешевск", 'ий', 'ая' ],
        [ "Завражн", 'ый', 'ая' ],
        [ "Задорожн", 'ый', 'ая' ],
        [ "Закревск", 'ий', 'ая' ],
        [ "Зинченко", '', '' ],
        [ "Илькун", '', '' ],
        [ "Калашник", '', '' ],
        [ "Каменских", '', '' ],
        [ "Кандинск", 'ий', 'ая' ],
        [ "Капица", '', '' ],
        [ "Касат", 'ый', 'ая' ],
        [ "Кирилловск", 'ий', 'ая' ],
        [ "Ковалевск", 'ий', 'ая' ],
        [ "Козарь", '', '' ],
        [ "Козловск", 'ий', 'ая' ],
        [ "Косяк", '', '' ],
        [ "Кравчук", '', '' ],
        [ "Кузьмич", '', '' ],
        [ "Лапидус", '', '' ],
        [ "Лебединск", 'ий', 'ая' ],
        [ "Леснич", 'ий', 'ая' ],
        [ "Лобан", '', '' ],
        [ "Логиновск", 'ий', 'ая' ],
        [ "Лосевск", 'ий', 'ая' ],
        [ "Майсак", '', '' ],
        [ "Маслак", '', '' ],
        [ "Машир", '', '' ],
        [ "Оболенск", 'ий', 'ая' ],
        [ "Ольховск", 'ий', 'ая' ],
        [ "Остапюк", '', '' ],
        [ "Островск", 'ий', 'ая' ],
        [ "Панькив", '', '' ],
        [ "Первак", '', '' ],
        [ "Покровск", 'ий', 'ая' ],
        [ "Полищук", '', '' ],
        [ "Полторак", '', '' ],
        [ "Приходько", '', '' ],
        [ "Рабинович", '', '' ],
        [ "Родзянко", '', '' ],
        [ "Рокоссовск", 'ий', 'ая' ],
        [ "Русских", '', '' ],
        [ "Сай", '', '' ],
        [ "Салко", '', '' ],
        [ "Семичаевск", 'ий', 'ая' ],
        [ "Сиз", 'ый', 'ая' ],
        [ "Случевск", 'ий', 'ая' ],
        [ "Смирнитск", 'ий', 'ая' ],
        [ "Соболевск", 'ий', 'ая' ],
        [ "Солодских", '', '' ],
        [ "Тихвинск", 'ий', 'ая' ],
        [ "Ткаченко", '', '' ],
        [ "Толст", 'ой', 'ая' ],
        [ "Торчинович", '', '' ],
        [ "Тредиаковск", 'ий', 'ая' ],
        [ "Циолковск", 'ий', 'ая' ],
        [ "Чал", 'ый', 'ая' ],
        [ "Челомей", '', '' ],
        [ "Черных", '', '' ],
        [ "Чиркаш", '', '' ],
        [ "Шевелёк", '', '' ],
        [ "Шуйск", 'ий', 'ая' ],
        [ "Шуличенко", '', '' ],
        [ "Шульга", '', '' ],
        [ "Шурша", '', '' ],
        [ "Щавельск", 'ий', 'ая' ],
        [ "Щегельск", 'ий', 'ая' ],
        [ "Щербатых", '', '' ],
        [ "Экель", '', '' ],
        [ "Эмануиль", '', '' ],
        [ "Эсце", '', '' ],
        [ "Этуш", '', '' ],
        [ "Якименко", '', '' ],
        [ "Якубович", '', '' ],
        [ "Янковск", 'ий', 'ая' ],
        [ "Янукович", '', '' ],
        [ "Ярмольник", '', '' ] ]

     CitiesByRegion = {
      'Брестская обл.' => %w(Брест Барановичи Береза Ганцевичи Дрогичин Жабинка Иваново Ивацевичи Каменец Кобрин 
        Лунинец Ляховичи Малорита Пинск Пружаны Столин),

      'Витебская обл.' => %w(Витебск Бешенковичи Браслав Верхнедвинск Глубокое Городок Докшицы Дубровно Лепель Лиозно 
        Миоры Новополоцк Орша Полоцк Поставы Россоны Сенно Толочин Ушачи Чашники Шарковщина Шумилино),

      'Минская обл.' => %w(Минск Березино Борисов Вилейка Воложин Дзержинск Жодино Клецк Копыль Крупки Логойск Любань 
        Марьина Горка Молодечно Мядель Несвиж Плещеницы Пуховичи Слуцк Смолевичи Солигорск Старые Дороги Столбцы 
        Узда Червень),

      'Гродненская обл.' => %w(Гродно Берестовица Волковыск Вороново Дятлово Зельва Ивье Кореличи Лида Мосты Новогрудок 
        Островец Ошмяны Свислочь Слоним Сморгонь Щучин),

      'Гомельская обл.' => %w(Гомель Брагин Буда-Кошелево Ветка Добруш Ельск Житковичи Жлобин Калинковичи Корма Лельчицы 
        Лоев Мозырь Наровля Октябрьский Петриков Речица Рогачев Светлогорск Хойники Чечерск),

      'Могилевская обл.' => %w(Могилев Белыничи Бобруйск Быхов Глуск Горки Дрибин Кировск Климовичи Кличев Костюковичи 
        Краснополье Кричев Круглое Мстиславль Осиповичи Славгород Хотимск Чаусы Чериков Шклов),
    }.freeze

    unless defined? RegionByCities
      region_by_cities = Hash.new { |hash, key| hash[key] = [] }

      CitiesByRegion.each do |region, cities|
        cities.each do |city|
          region_by_cities[city] << region if city
        end
      end

      RegionByCities = region_by_cities.freeze
      AllCities = RegionByCities.keys.freeze
    end

    # http://feofanov.fizteh.ru/toall/street.html
    StreetNames = ((%w{
      Советская Молодежная Центральная Школьная Новая Садовая Лесная Набережная
      Ленина Мира Октябрьская Зеленая Комсомольская Заречная Первомайская
      Гагарина Полевая Луговая Пионерская Кирова Юбилейная Северная
      Пролетарская Степная Пушкина Калинина Южная Колхозная Рабочая Солнечная
      Железнодорожная Восточная Заводская Чапаева Нагорная Строителей Береговая
      Победы Горького Кооперативная Красноармейская Совхозная Речная Спортивная
      Озерная Строительная Парковая Чкалова Мичурина Подгорная Дружбы Почтовая
      Партизанская Вокзальная Лермонтова Свободы Дорожная Дачная Маяковского
      Западная Фрунзе Дзержинского Московская Свердлова Некрасова Гоголя
      Красная Трудовая Шоссейная Чехова Коммунистическая Труда Комарова
      Матросова Островского Сосновая Клубная Куйбышева Крупской Березовая
      Больничная Интернациональная Суворова Цветочная Трактовая Ломоносова
      Горная Космонавтов Энергетиков Шевченко Весенняя Механизаторов
      Коммунальная Майская Энгельса Привокзальная Таежная Транспортная Овражная
      Светлая Вишневая Чернышевского Урицкого Ключевая Ворошилова Тургенева
      Толстого Песчаная Ленинградская Профсоюзная Буденного Орджоникидзе
      Герцена Верхняя Ленинская Кирпичная Мостовая Щорса Станционная
      Луначарского Энтузиастов Титова Лазо Уральская Линейная Пугачева
      Володарского Кутузова Фабричная Чайковского Магистральная Сибирская
      Крестьянская Мелиораторов Российская Новоселов Тихая Широкая Нижняя
      Белинского Тельмана Тимирязева Котовского Народная Промышленная Кольцевая
      Есенина Дальняя Крылова Декабристов Базарная Целинная Родниковая
      Фурманова Революционная Социалистическая Звездная Студенческая Гайдара
      Мирная Терешковой Кубанская Гаражная Фестивальная Гражданская Песочная
      Сиреневая Ватутина Сельская Кузнечная Пушкинская Крайняя Коммунаров
      Гвардейская Веселая Загородная Олимпийская Гастелло Жданова Радищева
      Нефтяников Осипенко Приозерная Рябиновая Заозерная Нахимова Боровая
      Жукова Павлова Урожайная Попова Торговая Жуковского Королева Донская
      Пограничная Огородная Пригородная Грибоедова Стадионная Менделеева
      Достоевского Репина Виноградная Циолковского Воровского Киевская
      Революции Индустриальная Красногвардейская Волжская Кошевого Пархоменко
      Свободная Кедровая Подлесная Полярная Раздольная Карьерная Мельничная
      Серова Украинская Шахтерская Запрудная Элеваторная Театральная
      Добролюбова Геологическая Болотная Красина Коминтерна Придорожная
      Кленовая Разина Черняховского Казачья Ветеранов Малая Пирогова Геологов
      Тукая Морская Волгоградская Димитрова Средняя Безымянная Краснофлотская
      Братская Тенистая Учительская Маркса Кавказская Ушакова Короткая
      Деповская Амурская Сенная Поселковая Юности Короленко Прудовая Шолохова
      Депутатская Авиационная Черемушки Кольцова Плеханова Аэродромная Большая
      Приморская Алтайская Макаренко Глинки Специалистов Халтурина Морозова
      Тополиная Ростовская Тракторная Коммуны Мелиоративная Ольховая Славянская
      Карбышева Баумана Радужная Правды Краснодарская Фадеева Стахановская
      Ярославская Челюскинцев Коллективная Ангарская Новостройка Шмидта
      Кузнецова Локомотивная Войкова Панфилова Ягодная Смоленская Тепличная
      Водопроводная Республиканская Автомобилистов Космодемьянской Осенняя
      Байкальская Седова Саратовская Казанская Блюхера Воронежская Брянская
      Производственная Спартака Техническая Енисейская Николаева Бабушкина
      Севастопольская Окружная Октября Щетинкина Орловская Хуторская Тупиковая
      Каштановая Омская Гончарова Привольная Щербакова Курортная Ивановская
      Выгонная Крымская Путейская Азина Проезжая Сурикова Краснознаменная
      Одесская Января Подстанция Логовая Высокая Ясная Портовая Снежная
      Санаторная Союзная Волкова Ульяновская Никитина Сахалинская Горняцкая
      Рылеева Прибрежная Химиков Рыбацкая Полтавская Тамбовская Красноярская
      Новосельская Проточная Черноморская Курчатова Минская Микрорайон Главная
      Докучаева Вольная Просвещения Смирнова Хвойная Космическая Моховая
      Макарова Курская Курганная Угловая Камская Инженерная Лесозаводская
      Астраханская Иванова Гафури Высоцкого Белорусская Бажова Кочубея
      Заовражная Азовская Ручейная Леонова Волочаевская Надежды Ставропольская
      Металлистов Вавилова Слободская Ульянова Тульская Харьковская Петровская
      Владимирская Семашко Высоковольтная Шаумяна Чайкиной Лазурная Ермака
      Дорожников Покровская Новгородская Ленская Сплавная Ударная Калужская
      Монтажников Прудная Шишкина Краснопартизанская Ореховая Таманская
      Иркутская Металлургов Отрадная Беляева Большевистская Троицкая Лесхозная
      Дружба Васильковая Серафимовича Ильича Механическая Невского Путевая
      Кузнецкая Физкультурная Леваневского Водников Вахитова Станиславского
      Черемуховая Советов Флотская Угольная Пожарского Папанина Просторная
      Поперечная Городская Победа Абрикосовая Бульварная Прохладная Томская
      Энергетическая Литейная Медицинская Заливная Журавлева Бригадная Культуры
      Минина Машиностроителей Детская ДОС Тюленина Запорожская Дальневосточная
      Громова Балтийская Февральская Толбухина Лунная Дарвина Высотная
      Рязанская Малиновая Механизаторская Яблоневая Красногорская Липовая
      Марата Горняков Переселенческая Новосибирская Рождественская Тухачевского
      Лебедева Железнодорожников Бакинская Приречная Хабаровская Тверская
      Малышева Айвазовского Самарская Складская Приовражная Хмельницкого
      Фруктовая Ключевская Мечникова Газовиков Продольная Калининградская
      Земляничная Авиаторов Бородина Связи Уфимская Демократическая Желябова
      Дубовая Прямая Калининская Кировская Менжинского Молодогвардейская
      Петрова Кравченко Лесопильная Дача Губкина Гористая Оренбургская Невская
      Оборонная Паровозная Артиллерийская Пржевальского Текстильщиков
      Спартаковская Янтарная Челюскина Костромская Никольская Новороссийская
      Обская Беговая Свобода Уссурийская Иртышская Конституции Лагерная
      Михайловская Либкнехта Пензенская Саянская Спасская Текстильная
      Международная Донецкая Футбольная Доватора Расковой Красносельская
      Мичуринская Лиманная Возрождения Арсеньева Пятигорская Ремесленная
      Рощинская Тюменская Ярославского Краснодонская Кривая Делегатская Первая
      Аксакова Артема Юлаева Челябинская Левитана Ладожская Летняя Лескова
      Малиновского Мусоргского Крутая Еловая Животноводов Пионеров Нефтебаза
      Офицерская Нестерова Связистов Стаханова Лобачевского Дружная Газовая
      Пихтовая Армейская Рудничная Прогонная Телеграфная Институтская Каменная
      Можайского Милицейская Лихачева Забайкальская Переездная Ветеринарная
      Федорова Ямская Каменская Знаменская Межевая Громовой Онежская Надречная
      Огарева Багратиона Торфяная Станичная Камчатская Джамбула Новаторов
      Ботаническая Апрельская Салтыкова-Щедрина Сеченова Солдатская Танкистов
      Березовская Андреева Аптечная Цимлянская Сосновская Чапаевская Захарова
      Ипподромная Литвинова Гранитная Грибная Дежнева Васильева Рокоссовского
      Промысловая Конечная Изумрудная Маслозаводская Охотничья Низовая
      Перспективная Базовая Республики Читинская Карельская Кустарная МОПРА
      Жемчужная Островная Парниковая Барнаульская Бородинская Аэропорт
      Александровская Рижская Рассветная Сельскохозяйственная Пристанская
      Хлебная Условная Зорге Козлова Заслонова Курганская Мурманская Дунайская
      Жигулевская Егорова Добровольского Писарева Орлова Нариманова Пестеля
      Автомобильная Большевиков Брестская Салавата Квартальная Люксембург
      Кропоткина Культурная Мамина-Сибиряка Гончарная Пермская Водная
      Беломорская Пугачевская Краснооктябрьская Кузбасская Днепровская
      Объездная Армавирская Верещагина Проселочная Ползунова Учебная Тукаева
      Филатова Стрельникова Львовская Кулибина Интернационала Водопьянова
      Соловьиная Черниговская Каспийская Известковая Ильинская Инициативная
      Луганская Покрышкина Новогодняя Обручева Алексеева Силикатная Ташкентская
      Худайбердина Магнитогорская Горская Вологодская Державина Бебеля Славы
      Русская Правобережная} +
      [
        '1 Мая', '30 лет Победы', '40 лет ВЛКСМ', '40 лет Победы', '40 лет Октября', '50 лет ВЛКСМ', '50 лет Победы',
        '50 лет Октября', '60 лет СССР', '60 лет Октября', '70 лет Октября', '8 Марта', '9 Мая', 'Зои Космодемьянской',
        'Мусы Джалиля', 'Лизы Чайкиной', 'Льва Толстого', 'Розы Люксембург', 'Сакко и Ванцетти', 'Карла Маркса',
        'Клары Цеткин', 'Олега Кошевого', 'Карла Либкнехта', 'Сергея Лазо', 'Дружбы Народов', 'Красных Зорь',
        'Красная Горка', 'Маршала Жукова', 'Степана Разина', 'Демьяна Бедного', 'Молодой Гвардии', 'Красных Партизан',
        'Максима Горького', 'Павлика Морозова', 'Богдана Хмельницкого', 'Сосновый бор', 'Салавата Юлаева',
        'Советской Армии', 'Парижской Коммуны'
      ]).map { |str| "ул. #{str}" } + %w{
        Школьный Садовый Лесной Зеленый Советский Новый Октябрьский
        Первомайский Комсомольский Пионерский Южный Северный Больничный Речной
        Почтовый Восточный Молодежный Рабочий Солнечный Колхозный Заводской
        Тихий Западный Степной Спортивный Центральный Луговой Кооперативный
        Полевой Пролетарский Мирный Железнодорожный Клубный Совхозный
        Красноармейский Дорожный Горный Заречный Озерный Майский Парковый
        Набережный Дачный Строительный Юбилейный Малый Короткий Сосновый
        Светлый Овражный Безымянный Березовый Береговой Пушкина Партизанский
        Нагорный Красный Чапаева Кирова Вокзальный Коммунальный Строителей
        Кузнечный Кирпичный Базарный Калинина Гагарина Песчаный Цветочный
        Ленина Веселый Трудовой Мостовой Дальний Торговый Мира Мельничный
        Вишневый Транспортный Московский Лермонтова Горького Некрасова Чехова
        Маяковского Фабричный Чкалова Широкий Подгорный Дружбы Весенний
        Тупиковый Шоссейный Средний Гоголя Матросова Ключевой Шевченко Крупской
        Победы Свободный Узкий Звездный Коммунистический Линейный Таежный
        Ленинский Свердлова Донской Островского Фрунзе Дзержинского Пушкинский
        Станционный Мичурина Гаражный Казачий Кривой Глухой Верхний Тургенева
        Суворова Кольцевой Куйбышева Виноградный Свободы Крайний Крестьянский
        Песочный Интернациональный Кубанский Банный Чернышевского Гвардейский
        Уральский Огородный Братский Театральный Крутой Пожарный Родниковый
        Урицкого Промышленный Сибирский Ломоносова Кировский Карьерный
        Механизаторов Болотный Привокзальный Энергетиков Гражданский Нижний
        Володарского Энгельса Ленинградский Урожайный Тупой Щорса Буденного
        Сенной Котовского Сельский Сиреневый Толстого Луначарского Волжский
        Тракторный Стадионный Кедровый Комарова Герцена Марта Прямой
        Революционный Целинный Элеваторный Киевский Крылова Детский Аптечный
        Профсоюзный Учительский Каменный Кутузова Загородный Пугачева Радужный
        Пригородный}.map { |str| str.end_with?("й") ? "#{str} пер." : "пер. #{str}" } +
      [
        'пл. Ленина', 'пр-т Ленина', 'Советская пл.', 'Школьный проезд', 'Микрорайон', 'пр-т Мира',
        '1 линия', '2 линия', 'пл. Революции', '3 линия', 'пл. Победы', 'мкр. Северный', 'Садовый проезд',
        'Лесной проезд', 'Московское ш.', 'пл. Свободы пл', 'Северный проезд'
      ]
    ).freeze

    # вдохновлено http://www.brendogenerator.ru
    #
    # префикс $ у слова означает, что оно ставится в конец названия
    # префикс - у слова означает, что оно не должно ставиться в конец названия
    CompanyNameParts = {
      :prom => %w($Автоматика -Бур Волокно Гео Гибрид $Гидравлика Гидро Гипро Деталь Дизель Запчасть
                  $Индустрия Инструмент Кран Лазер Маш Мех Монтаж Нано $Обработка $Переработка Пром
                  -Резино Рем Рециклинг -Станко Тех Техно Трак -Тракторо Утиль $Утилизация),

      :stroy => %w(Архитект Бетон Дверь Дизайн Дор -Жил Кирпич Мастер Монолит
                   Монтаж Окно Ремонт Строй Цемент),

      :torg => %w(-Загран Ком Коммерц Комплект Комплектация Маркет Опт $Поставка
                  Сбыт Снаб Торг Трейд Трейдинг),

      :resurs => %w(Атом -Био -Вод Втор Газ Лес Лесхоз -Нефте -Орг Полимер
                   -Природ Ресурс Синтез Сырье Тепло -Термо -Угле Хим -Эко $Экология Электро
                    Энерго),

      :metall => %w(Втормет Комбинат Металл Метиз $Поковка Прокат Сплав Сталь
                    Стандарт -Труб Ферро Цветмет Чермет),

      :it => %w($Автоматизация Веб Инфо Информ ИТ Ком Медиа Радио Сайт Связь Сеть Софт -Теле Телеком Хост Хостинг),

      :sport => %w(-Вело Вояж Загран Олимп $Поездка Спорт Тур Экстрим),

      :transport => %w(Авиа Авто Аэро Груз $Доставка -Желдор $Перевозка
                       Транзит Транс Экспресс),

      :obr => %w(Академ $Академия -Науч Пед Стандарт Тренинг -Учеб $Школа $НИИ),

      :legprom => %w(Джинс Кож Костюм $Одежда Пошив Текстиль Трикотаж),

      :pischevka => %w(Агро Вино -Загот $Заготовка Зерно -Колбас $Колбасы Кондитер $Консервы КРС
                       -Ликеро Масло Мясо Пиво -Пище -Птице -Рыб $Рыба Сало -Свино -Сель 
                       Сельхоз -Спирто Сыр -Сыро $Удобрение -Хладо Хлеб Хоз),

      :fin => %w($Аналитика Аудит Банк Брокер -Бух -Валют Инвест $Ипотека Капитал Консалт $Консалтинг Кредит Лизинг
                 Резерв Страх Траст Финанс $Фонд Эконом),

      :gos => %w(-Воен -Гос Граждан $Контроль $Надзор Налог Мин Обл Оборон Регион -Управ $Управление $Учреждение),

      :common => %w(Альянс Бизнес Блок Комбинат Комплект $Мануфактура Продукт Проект -Проф Сервис $Системы Спец
                    Стандарт $Станция $Техника $Технология $Фабрика Фактор Центр $Цивилизация)
    }.freeze

    Industries = (CompanyNameParts.keys - [:common]).freeze

    CompanyNameSuffixes = %w(-Про -Элит -Люкс -Гарант -Эксклюзив -Премиум 
                             Групп Плаза Кампани Холдинг Индастриз Продакшенз Инкорпорейтед)
  end
end
